unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, 
    Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
const
  UTF8Test1 = #$C3#$84#$C3#$96#$C3#$9C;
  UTF8Test2 = 'ÄÖÜ';
  CP1252Test = #$C4#$D6#$DC;

  procedure Test(aName: String; Encoding: TSystemCodePage);
  var
    SL: TStringList;
    rs: RawByteString;
  begin
    SL := TStringList.Create;

    rs := UTF8Test1;
    SetCodePage(rs, CP_UTF8, False);
    SetCodePage(rs, Encoding, True);
    SL.Add(rs);

    rs := UTF8Test2;
    SetCodePage(rs, CP_UTF8, False);
    SetCodePage(rs, Encoding, True);
    SL.Add(rs);

    rs := CP1252Test;
    SetCodePage(rs, 1252, False);
    SetCodePage(rs, Encoding, True);
    SL.Add(rs);

{    rs := SL.Text;
    SetCodePage(rs, Encoding, True);
    SL.Text := rs;
}
    SL.SaveToFile(aName);
    FreeAndNil(SL);
  end;

begin
  Test('UTF8Test1.txt', CP_UTF8);
  Test('UTF8Test2.txt', CP_UTF8);
  Test('CP1252Test.txt', 1252);
end;

end.

